import win32.windows;
import win32.windef;
import win32.commctrl;

import std.stdio;
import std.string;
import std.utf;

struct FontMan
{
  LOGFONT lf ;

  void init(int Height=-12, const BYTE PaF=VARIABLE_PITCH, string facename=null){
    lf.lfHeight         = Height ;
    lf.lfWidth          =  0 ;
    lf.lfEscapement     =  0 ;
    lf.lfOrientation    =  0 ;
    lf.lfWeight         = FW_REGULAR ;
    lf.lfItalic         = false ;
    lf.lfUnderline      = false ;
    lf.lfStrikeOut      = false ;
    lf.lfCharSet        = DEFAULT_CHARSET ;
    lf.lfOutPrecision   = OUT_DEFAULT_PRECIS ;
    lf.lfClipPrecision  = CLIP_DEFAULT_PRECIS ;
    lf.lfQuality        = DEFAULT_QUALITY ;
    lf.lfPitchAndFamily = PaF ;
    lf.lfFaceName[0]    = 0 ;
    if( facename!=null ){
      wstring wfacename=toUTF16(facename ~ "\0") ;
      if( wfacename.length<=32 ){
        wchar[] fn=wfacename.dup ;
        lf.lfFaceName[0..fn.length] = fn[0..$] ;
      }
    }
  }

  void setLOGFONT(LOGFONT lf){
    this.lf = lf ;
  }

  HFONT createHFONT(){
    return( CreateFontIndirect(&lf) ) ;
  }

  void setHeight(int size){
    lf.lfHeight = size ;
  }

  void setWeight(const LONG Weight){
    lf.lfWeight = Weight ;
  }

  void setPitchAndFamily(const BYTE PitchAndFamily){
    lf.lfPitchAndFamily = PitchAndFamily ;
  }

}
