import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import win32frame.Split;
import win32frame.MsgBox;

import FontMan;
import TextView;
import StringDB;

import std.stdio;
import std.string;
import std.utf;

class MainPanel : WindowObject {
  TextView   textview1 ;
  StringDB   strdb ;
  FontMan    fontman ;
  int        fmt_type=0 ;
  int        fmt_size=1 ;

  this(string name, string ClassName) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(null , cast(wchar*)(IDI_APPLICATION));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
    this.registwinc() ;
    fontman.init(-12,FIXED_PITCH,"ＭＳ ゴシック") ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      break ;

    case WM_CREATE:
      textview1 = new TextView("TextView1","TextView1") ;
      textview1.setPosition(0,0,200,200) ;
      textview1.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL ) ;

      addObject( textview1, cast(HMENU)(901), true, true ) ;
      break ;

    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;

    case WM_MOVE:
      break ;

    case WM_SIZE:
      break;

    case WM_LBUTTONDOWN:
    case WM_LBUTTONUP:
    case WM_LBUTTONDBLCLK:
    case WM_RBUTTONDOWN:
    case WM_RBUTTONUP:
    case WM_RBUTTONDBLCLK:
    case WM_MOUSEMOVE:
      break ;

    case WM_COMMAND:
      if( LOWORD(wp)>=800 && LOWORD(wp)<900 ){
        sync_scrollbar(cast(int)(wp),cast(int)(lp)) ;
      }else{
        switch( LOWORD(wp) ){
        default :
          break ;
        }
      }
      break ;

    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int sync_scrollbar(int wp, int lp){
    switch( LOWORD(wp) ){
        break;
      default :
        break ;
    }
    return(0) ;
  }

  int readfile(string fname){
    strdb = new StringDB() ;
    strdb.setFormat(fmt_type,fmt_size) ;
    try{
      strdb.readfile(fname) ;
    }catch(Exception e){
      auto msgbox = new MsgBox(getHWND(), "File Read Error", "Message", MB_OK ) ;
      msgbox.create() ;
      return(-1) ;
    }
    core.memory.GC.minimize() ;

    textview1.setStringDB(strdb) ;
    return(0) ;
  }

  int getMaxColumns(){
    if( strdb !is null ){
      return(strdb.getMaxColumns()) ;
    }
    return(-1) ;
  }

  int setFormat(int type, int size){
    fmt_type=type ;
    fmt_size=size ;
    if( strdb !is null ){
      strdb.setFormat(type,size) ;
      textview1.reDraw() ;
    }
    return(0) ;
  }

  int[] getFormat(){
    if( strdb !is null ){
      return(strdb.getFormat()) ;
    }
    return(null) ;
  }

  int changeFont(LOGFONT lf){
    textview1.changeFont(lf) ;
    fontman.setLOGFONT(lf) ;
    return(0) ;
  }

  LOGFONT getViewLOGFONT(){
    return(fontman.lf) ;
  }
}
