import std.stdio;
import std.string;
import std.getopt;

import StringDB;

int main(string[] args){
  int  size=1 ;
  bool little_endian=false ;
  bool opt_help=false ;
  bool opt_version=false ;
  StringDB strdb ;

  try{
    getopt(args,
           std.getopt.config.caseSensitive,
           "size|s",    &size,
           "little|l",  &little_endian,
           "version|V", &opt_version,
           "help|h",    &opt_help ) ;
  }catch(Exception e){
    writef("%s\n",e.msg) ;
    printHelp() ;
    return(-1) ;
  }

  if( opt_version==true ){
    writef("bdump Ver0.01\n") ;
    return(0) ;
  }
  if( opt_help==true ||
      !(size==1 || size==2 || size==4 || size==8) ){
    printHelp() ;
    return(-1) ;
  }

  if( args.length==1 ) args ~= "-" ;
  foreach( n, fname ; args ){
    if( n==0 ) continue ;

    strdb=new StringDB() ;
    try {
      strdb.readfile(fname) ;
    }catch(Exception e){
      writef("Error : can not read file(%s)\n", fname) ;
      continue ;
    }
    strdb.setFormat(little_endian==false ? 0 : 1, size) ;
    int lnum=strdb.getMaxLines() ;
    writef("%s\n",strdb.getCaptionString()) ;
    for( int i=0 ; i<lnum ; i++ ){
      wstring[] lines = strdb.getStringDB(i) ;
      writef("%s\n", lines[0]) ;
    }
  }

  return(0) ;
}

void printHelp()
{
  writef("Usage: bdump [OPTION]... [FILE]...\n"
         "Dump files in Hex formats\n"
         "  -s n, --size n   Size bytes per integer(n=1 or 2 or 4 or 8)\n"
         "  -l  , --little   Little endian dump mode.\n"
         "  -V  , --version  Print version.\n"
         "  -h  , --help     Print this help.\n"
         );
  return ;
}
