import win32.windows;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;

uint MAKELPARAM(ushort a, ushort b) { return cast(uint) ((b << 16) | a); }

class ListBox : WindowObject {

  this(string name) {
    winc.lpszClassName  = toUTFz!(wchar*)("LISTBOX") ;
    setStyle( (WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN) ) ;
    super(name) ;
  }

  ~this(){
    resetContent() ;
  }

  //win32/winuser.d:const LB_ADDFILE=406;
  int addFile(LPCTSTR lpszFile){
    return( cast(int)(sendmsg(LB_ADDFILE,0,cast(LPARAM)(lpszFile))) ) ;
  }
  int addFile(string strFile){
    return( cast(int)(sendmsg(LB_ADDFILE,0,cast(LPARAM)(toUTFz!(wchar*)(strFile)))) ) ;
  }
  //win32/winuser.d:const LB_ADDSTRING=384;
  int addString(LPCTSTR lpsz){
    return( cast(int)(sendmsg(LB_ADDSTRING,0,cast(LPARAM)(lpsz))) ) ;
  }
  int addString(string strsz){
    return( cast(int)(sendmsg(LB_ADDSTRING,0,cast(LPARAM)(toUTFz!(wchar*)(strsz)))) ) ;
  }
  //win32/winuser.d:const LB_DELETESTRING=386;
  int deleteString(int index){
    return( cast(int)(sendmsg(LB_DELETESTRING,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_DIR=397;
  int dir(uint attrs, LPCTSTR lpszFileSpec){
    return( cast(int)(sendmsg(LB_DIR,cast(WPARAM)(attrs),cast(LPARAM)(lpszFileSpec))) ) ;
  }
  int dir(uint attrs, string strFileSpec){
    return( cast(int)(sendmsg(LB_DIR,cast(WPARAM)(attrs),cast(LPARAM)(toUTFz!(wchar*)(strFileSpec)))) ) ;
  }
  //win32/winuser.d:const LB_FINDSTRING=399;
  int findString(int indexStart, LPCTSTR lpszFind){
    return( cast(int)(sendmsg(LB_FINDSTRING,cast(WPARAM)(indexStart),cast(LPARAM)(lpszFind))) ) ;
  }
  int findString(int indexStart, string strFind){
    return( cast(int)(sendmsg(LB_FINDSTRING,cast(WPARAM)(indexStart),cast(LPARAM)(toUTFz!(wchar*)(strFind)))) ) ;
  }
  //win32/winuser.d:const LB_FINDSTRINGEXACT=418;
  int findStringExact(int indexStart, LPCTSTR lpszFind){
    return( cast(int)(sendmsg(LB_FINDSTRINGEXACT,cast(WPARAM)(indexStart),cast(LPARAM)(lpszFind))) ) ;
  }
  int findStringExact(int indexStart, string strFind){
    return( cast(int)(sendmsg(LB_FINDSTRINGEXACT,cast(WPARAM)(indexStart),cast(LPARAM)(toUTFz!(wchar*)(strFind)))) ) ;
  }
  //win32/winuser.d:const LB_GETANCHORINDEX=413;
  int getAnchorIndex(){
    return( cast(int)(sendmsg(LB_GETANCHORINDEX,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETCARETINDEX=415;
  int getCaretIndex(){
    return( cast(int)(sendmsg(LB_GETCARETINDEX,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETCOUNT=395;
  int getCount(){
    return( cast(int)(sendmsg(LB_GETCOUNT,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETCURSEL=392;
  int getCurSel(){
    return( cast(int)(sendmsg(LB_GETCURSEL,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETHORIZONTALEXTENT=403;
  int getHorizontalExtent(){
    return( cast(int)(sendmsg(LB_GETHORIZONTALEXTENT,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETITEMDATA=409;
  int getItemData(int index){
    return( cast(int)(sendmsg(LB_GETITEMDATA,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_GETITEMHEIGHT=417;
  int getItemHeight(int index){
    return( cast(int)(sendmsg(LB_GETITEMHEIGHT,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_GETITEMRECT=408;
  int getItemRect(int index, RECT* lprc){
    return( cast(int)(sendmsg(LB_GETITEMRECT,cast(WPARAM)(index),cast(LPARAM)(lprc))) ) ;
  }
  //win32/winuser.d:const LB_GETLOCALE=422;
  int getLocale(){
    return( cast(int)(sendmsg(LB_GETLOCALE,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETSEL=391;
  int getSel(int index){
    return( cast(int)(sendmsg(LB_GETSEL,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_GETSELCOUNT=400;
  int getSelCount(){
    return( cast(int)(sendmsg(LB_GETSELCOUNT,0,0)) ) ;
  }
  //win32/winuser.d:const LB_GETSELITEMS=401;
  int getSelItems(int cItems, int* lpItems){
    return( cast(int)(sendmsg(LB_GETSELITEMS,cast(WPARAM)(cItems),cast(LPARAM)(lpItems))) ) ;
  }
  //win32/winuser.d:const LB_GETTEXT=393;
  int getText(int index, LPCTSTR lpszBuffer){
    return( cast(int)(sendmsg(LB_GETTEXT,cast(WPARAM)(index),cast(LPARAM)(lpszBuffer))) ) ;
  }
  //win32/winuser.d:const LB_GETTEXTLEN=394;
  int getTextLen(int index){
    return( cast(int)(sendmsg(LB_GETTEXTLEN,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_GETTOPINDEX=398;
  int getTopIndex(){
    return( cast(int)(sendmsg(LB_GETTOPINDEX,0,0)) ) ;
  }
  //win32/winuser.d:const LB_INITSTORAGE=424;
  int initStorage(short itemsize, LPARAM memsize){
    return( cast(int)(sendmsg(LB_INITSTORAGE,cast(WPARAM)(itemsize),memsize)) ) ;
  }
  //win32/winuser.d:const LB_INSERTSTRING=385;
  int insertString(int index, LPCTSTR lpsz){
    return( cast(int)(sendmsg(LB_INSERTSTRING,cast(WPARAM)(index),cast(LPARAM)(lpsz))) ) ;
  }
  int insertString(int index, string strsz){
    return( cast(int)(sendmsg(LB_INSERTSTRING,cast(WPARAM)(index),cast(LPARAM)(toUTFz!(wchar*)(strsz)))) ) ;
  }
  //win32/winuser.d:const LB_ITEMFROMPOINT=425;
  int itemFromPoint(short cx, short cy){
    return( cast(int)(sendmsg(LB_ITEMFROMPOINT,0,cast(LPARAM)(MAKELPARAM(cx,cy)))) ) ;
  }
  //win32/winuser.d:const LB_RESETCONTENT=388;
  int resetContent(){
    return( cast(int)(sendmsg(LB_RESETCONTENT,0,0)) ) ;
  }
  //win32/winuser.d:const LB_SELECTSTRING=396;
  int selectString(int indexStart, LPCTSTR lpszFind){
    return( cast(int)(sendmsg(LB_SELECTSTRING,cast(WPARAM)(indexStart),cast(LPARAM)(lpszFind))) ) ;
  }
  int selectString(int indexStart, string strFind){
    return( cast(int)(sendmsg(LB_SELECTSTRING,cast(WPARAM)(indexStart),cast(LPARAM)(toUTFz!(wchar*)(strFind)))) ) ;
  }
  //win32/winuser.d:const LB_SELITEMRANGE=411;
  int selItemRange(int fSelect, ushort first, ushort last){
    return( cast(int)(sendmsg(LB_SELITEMRANGE,cast(WPARAM)(fSelect),cast(LPARAM)(MAKELPARAM(first,last)))) ) ;
  }
  //win32/winuser.d:const LB_SELITEMRANGEEX=387;
  int selItemRangeEx(int first, int last){
    return( cast(int)(sendmsg(LB_SELITEMRANGEEX,cast(WPARAM)(first),cast(LPARAM)(last))) ) ;
  }
  //win32/winuser.d:const LB_SETANCHORINDEX=412;
  int setAnchorIndex(int index){
    return( cast(int)(sendmsg(LB_SETANCHORINDEX,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_SETCARETINDEX=414;
  int setCaretIndex(int index){
    return( cast(int)(sendmsg(LB_SETCARETINDEX,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_SETCOLUMNWIDTH=405;
  int setColumnWidth(int cxColumn){
    return( cast(int)(sendmsg(LB_SETCOLUMNWIDTH,cast(WPARAM)(cxColumn),0)) ) ;
  }
  //win32/winuser.d:const LB_SETCOUNT=423;
  int setCount(int count){
    return( cast(int)(sendmsg(LB_SETCOUNT,cast(WPARAM)(count),0)) ) ;
  }
  //win32/winuser.d:const LB_SETCURSEL=390;
  int setCurSel(int index){
    return( cast(int)(sendmsg(LB_SETCURSEL,cast(WPARAM)(index),0)) ) ;
  }
  //win32/winuser.d:const LB_SETHORIZONTALEXTENT=404;
  int setHorizontalExtent(int cxExtent){
    return( cast(int)(sendmsg(LB_SETHORIZONTALEXTENT,cast(WPARAM)(cxExtent),0)) ) ;
  }
  //win32/winuser.d:const LB_SETITEMDATA=410;
  int setItemData(int index, LPARAM data){
    return( cast(int)(sendmsg(LB_SETITEMDATA,cast(WPARAM)(index),data)) ) ;
  }
  //win32/winuser.d:const LB_SETITEMHEIGHT=416;
  int setItemHeight(int index, short cy){
    return( cast(int)(sendmsg(LB_SETITEMHEIGHT,cast(WPARAM)(index),cast(LPARAM)(MAKELPARAM(cy,0)))) ) ;
  }
  //win32/winuser.d:const LB_SETLOCALE=421;
  int setLocale(int localeID){
    return( cast(int)(sendmsg(LB_SETLOCALE,cast(WPARAM)(localeID),0)) ) ;
  }
  //win32/winuser.d:const LB_SETSEL=389;
  int setSel(int fSelect, int index){
    return( cast(int)(sendmsg(LB_SETSEL,cast(WPARAM)(fSelect),cast(LPARAM)(index))) ) ;
  }
  //win32/winuser.d:const LB_SETTABSTOPS=402;
  int setTabStops(int cTabs, int* lpTabs){
    return( cast(int)(sendmsg(LB_SETTABSTOPS,cast(WPARAM)(cTabs),cast(LPARAM)(lpTabs))) ) ;
  }
  //win32/winuser.d:const LB_SETTOPINDEX=407;
  int setTopIndex(int indexTop){
    return( cast(int)(sendmsg(LB_SETTOPINDEX,cast(WPARAM)(indexTop),0)) ) ;
  }
  //win32/winuser.d:const LB_GETLISTBOXINFO=434;
  int getListBoxInfo(){
    return( cast(int)(sendmsg(LB_GETLISTBOXINFO,0,0)) ) ;
  }

  //win32/winuser.d:const LB_CTLCODE=0;
  //win32/winuser.d:const LB_OKAY=0;
  //win32/winuser.d:const LB_ERR=-1;
  //win32/winuser.d:const LB_ERRSPACE=-2;

  string getCurLabel() {
    int    cur       = getCurSel() ;
    int    label_len = getTextLen(cur) ;
    string retstr    = "" ;

    if( label_len != LB_ERR ){
      wchar[] strbuf = new wchar[label_len+1] ;
      if( getText(cur, strbuf.ptr) != LB_ERR ){
        retstr = toUTF8( strbuf[0..label_len] ) ;
      }
    }
    return( retstr ) ;
  }

}
