import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.writek;
import win32frame.WindowObject;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar ;
import win32frame.ToolBarEx;
import win32frame.Rebar;

import std.stdio;
import std.string;
import std.utf;

class MainWindow : Frame {
  Rebar  reBar ;
  RECT   rebarRC ;
  RECT   stbRC ;
  bool   with_rebar=false ;
  HWND[] bc_wmsize_List ; // WM_SIZEをブロードキャストするHWNDリスト

  this(string name, string ClassName) {
    if( winc.lpszClassName==null ){
      winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    }
    super(name) ;
  }

  int withRebar(){
    with_rebar=true ;
    return(0) ;
  }

  bool setMenu(WindowMenu menu){
    return( cast(bool)( SetMenu(this.getHWND() , menu.getHMENU()) ) ) ;
  }

  int setREBARBANDINFO(REBARBANDINFO rbbi){
    if( with_rebar==true ){
      if( reBar !is null ){
        return(reBar.setREBARBANDINFO(rbbi)) ;
      }
    }
    return(-1) ;
  }

  int addonRebar(WindowObject WObj){
    if( with_rebar==false ) return(-1) ;
    return( reBar.addWindowObject(WObj) ) ;
  }

  int addonRebar(ToolBarEx toolbar){
    if( with_rebar==false ) return(-1) ;
    return( reBar.addTool(toolbar) ) ;
  }

  int addStatusBar(StatusBar StBar, string msg){
    HWND stbhwnd ;
    int  ret ;
    ret = StBar.create(this.getHWND(), msg) ;
    stbhwnd = StBar.getHWND() ;
    if( stbhwnd != null ){
      bc_wmsize_List.length = bc_wmsize_List.length+1 ;
      bc_wmsize_List[$-1]=stbhwnd ;
      setStatusbar(StBar) ;
      GetWindowRect( stbhwnd, &stbRC ) ;
    }
    return( ret ) ;
  }

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE:
      if( with_rebar==true ){
        reBar = new Rebar("Rebar") ;
        addObject(reBar, null, true, true) ;
      }
      setMainWinHWND(hwnd) ;
      break ;

    case WM_NOTIFY :
      LPNMHDR lpnmhdr ;
      lpnmhdr = cast(LPNMHDR)(lp) ;
      if( with_rebar==true ){
        if( lpnmhdr.hwndFrom == reBar.getHWND() ){
          if( lpnmhdr.code == RBN_HEIGHTCHANGE ){
            InvalidateRect(hwnd, null, true) ;
            UpdateWindow(reBar.getHWND()) ;
            GetClientRect( reBar.getHWND(), &rebarRC ) ;
            rebarRC.bottom+=6 ;
            RECT rc ;
            GetWindowRect(hwnd, &rc ) ;
            sendmsg(WM_SIZE, 0, ((rc.right - rc.left)<<16 | (rc.bottom - rc.top)) ) ;
          }
        }
      }
      break ;

    case WM_MOVE :
      _winX=LOWORD(lp) ;
      _winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      _winW=LOWORD(lp) ;
      _winH=HIWORD(lp) ;

      int stbHeight = stbRC.bottom - stbRC.top ;
      RECT rc_pcl ; GetClientRect( hwnd, &rc_pcl ) ; rc_pcl.bottom -= (stbHeight+rebarRC.bottom) ;
      int cWidth = rc_pcl.right -rc_pcl.left ;
      int cHeight= rc_pcl.bottom-rc_pcl.top  ;
      foreach_reverse( i, WOBJ ; WOBJ_List ){
        if( WOBJ !is null ){
          if( with_rebar==true && reBar.getHWND()==WOBJ.getHWND() ){
            RECT rc ; GetClientRect( hwnd, &rc ) ;
            MoveWindow( reBar.getHWND(), 0, 0, (rc.right - rc.left), (rc.bottom - rc.top), false ) ;
            InvalidateRect( reBar.getHWND(), null, true ) ;
          }else{
            switch( WOBJ.fittype ){
            case FIT.NONE :
              break ;
            case FIT.WIDTH :
              MoveWindow( WOBJ.getHWND(), 0, WOBJ.winY+rebarRC.bottom, cWidth, WOBJ.winH, true ) ;
              break ;
            case FIT.HEIGHT :
              MoveWindow( WOBJ.getHWND(), WOBJ.winX, 0+rebarRC.bottom, WOBJ.winW, cHeight, true ) ;
              break ;
            case FIT.BOTH :
              MoveWindow( WOBJ.getHWND(), 0, 0+rebarRC.bottom, cWidth, cHeight, true ) ;
              break ;
            default : core.exception.onSwitchError() ;
            }
            RedrawWindow(WOBJ.getHWND(),null,null, RDW_INVALIDATE) ;
          }
        }
      }
      foreach_reverse( i, bc_wmsize ; bc_wmsize_List ){
        sendmsg( bc_wmsize, WM_SIZE, wp, lp);
      }
      break ;

    default : break ;
    }

    return( this.proc(hwnd , msg , wp , lp) ) ;
  }
}
