import win32.windows;
import std.string;
import std.stdio;
import win32frame.writek;
import win32frame.WindowBase ;
import win32frame.ToolTip ;
import win32frame.StatusBar ;

enum FIT {
  NONE  = 0,
  WIDTH = 1,
  HEIGHT= 2,
  BOTH  = 3
} ;

class WindowObject : WindowBase {
  int _winX=CW_USEDEFAULT ;
  int _winY=CW_USEDEFAULT ;
  int _winW=CW_USEDEFAULT ;
  int _winH=CW_USEDEFAULT ;
  int style  =0 ;
  int exstyle=0 ;
  FIT fittype=FIT.NONE ;
  ToolTip tooltip ;
  shared static StatusBar _statusBar ;
  shared static HWND MainWindowHWND  ;

  WindowObject[]    WOBJ_List ;

  this( string name ) {
    super(name) ;
  }

  @property int winX(){ return(_winX) ; }
  @property int winY(){ return(_winY) ; }
  @property int winW(){ return(_winW) ; }
  @property int winH(){ return(_winH) ; }

  int setPosition(int x, int y, int w, int h){
    _winX = x ;
    _winY = y ;
    _winW = w ;
    _winH = h ;
    return(0) ;
  }

  int setStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }

  int getStyle(){
    return(this.style) ;
  }

  int setExStyle(int exstyle){
    this.exstyle=exstyle ;
    return(0) ;
  }

  int addExStyle(int addexstyle){
    this.exstyle |= addexstyle ;
    return(0) ;
  }

  int getExStyle(){
    return(this.exstyle) ;
  }

  int addObject(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    int ret = WObj.create(this.getHWND(), hmenu) ;
    if( WObj.getHWND() != null ){
      WOBJ_List.length = WOBJ_List.length + 1 ;
      WOBJ_List[$-1]=WObj ;
      WOBJ_List[$-1].fittype = ((fitWidth==true) ? FIT.WIDTH : FIT.NONE) + ((fitHeight==true) ? FIT.HEIGHT : FIT.NONE)  ;
    }
    return( ret ) ;
  }

  int delObject(WindowObject WObj){
    return( _delObject(WObj,false) ) ;
  }

  int _delObject(WindowObject WObj, bool fixedlist=false){
    if( WObj !is null ){
      int flag=0 ;
      for( int i=0 ; i<WOBJ_List.length ; i++ ){
        if( WOBJ_List[i] is WObj ){
          clear(WOBJ_List[i]) ;
          if( fixedlist==false ){
            for( int j=i+1 ; j<WOBJ_List.length ; j++ ){
              WOBJ_List[j-1]=WOBJ_List[j] ;
            }
            WOBJ_List.length=WOBJ_List.length-1 ;
          }else{
            WOBJ_List[i]=null ;
          }
          flag=1 ;
          break ;
        }
      }
      if( flag==0 ){
        if( this.getHWND()==WObj.getParentHWND() ){ //この条件は成立しないハズ
          clear(WObj) ;
        }
      }
    }
    return( 0 ) ;
  }

  int addToolTip(ToolTip TooltipOBJ){
    if( TooltipOBJ !is null ){
      int ret ;
      tooltip = TooltipOBJ ;
      ret = tooltip.create(this.getHWND()) ;
      tooltip.setClientRect() ;
      return(ret) ;
    }
    return(-1) ;
  }

  int setMainWinHWND(HWND mainwinhwnd){
    if( getMainWinHWND()==null ){
      MainWindowHWND=cast(shared HWND)(mainwinhwnd) ;
      return(0) ;
    }
    return(-1) ;
  }

  HWND getMainWinHWND(){
    return( cast(HWND)(MainWindowHWND) ) ;
  }

  int create(HWND phwnd, HMENU hmenu){
    return( lowcreate( exstyle, style, winX,winY,winW,winH, phwnd, hmenu) ) ;
  }

  int show(int cmdshow=SW_SHOW){
    if( this.getHWND() !=null ){
      return( ShowWindow(this.getHWND(),cmdshow) ) ;
    }
    return(-1) ;
  }

  int hide(){
    if( this.getHWND() !=null ){
      return( ShowWindow(this.getHWND(),SW_HIDE) ) ;
    }
    return(-1) ;
  }

  int enable(){
    if( this.getHWND()!=null ){
      return(EnableWindow(this.getHWND(), TRUE)) ;
    }
    return(-1) ;
  }

  int disable(){
    if( this.getHWND()!=null ){
      return(EnableWindow(this.getHWND(), FALSE)) ;
    }
    return(-1) ;
  }

  int setStatusbar(StatusBar StBar){
    _statusBar = cast(shared StatusBar)(StBar) ;
    return(0) ;
  }

  StatusBar getStatusbar(){
    return(cast(StatusBar)(_statusBar)) ;
  }

  int printStatusbar(string str){
    if( _statusBar !is null ){
      StatusBar statbar = cast(StatusBar)(_statusBar) ;
      statbar.setText(str) ;
    }
    return(0) ;
  }


  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE :
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      _winX=0 ;
      _winY=0 ;
      _winW=rc.right  ;
      _winH=rc.bottom ;
      break ;

    case WM_MOVE :
      _winX=LOWORD(lp) ;
      _winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      _winW=LOWORD(lp) ;
      _winH=HIWORD(lp) ;
      RECT rc_pcl ; GetClientRect( hwnd, &rc_pcl ) ;
      RECT rc_pwd ; GetWindowRect( hwnd, &rc_pwd ) ;
      RECT nullRC ;
      foreach_reverse( i, WOBJ ; WOBJ_List ){
        if( WOBJ !is null ){
          WOBJfitting(WOBJ, nullRC, rc_pwd, rc_pcl) ;
        }
      }
      break ;

    default : break ;
    }

    return( this.proc(hwnd , msg , wp , lp) ) ;
  }


  int WOBJfitting(WindowObject WOBJ, RECT rbRC, RECT pwdRC, RECT pclRC){
    int rbHeight = rbRC.bottom ;
    int pWidth  = (pclRC.right - pclRC.left) ;
    int pHeight = (pclRC.bottom- pclRC.top ) ;
    RECT cwRC ;
    GetWindowRect( WOBJ.getHWND(), &cwRC ) ;
    cwRC.top    -= pwdRC.top  ;
    cwRC.bottom -= pwdRC.top  ;
    cwRC.left   -= pwdRC.left ;
    cwRC.right  -= pwdRC.left ;
    int cWidth  = (cwRC.right - cwRC.left) ;
    int cHeight = (cwRC.bottom- cwRC.top ) ;

    switch( WOBJ.fittype ){
    case FIT.NONE :
      break ;
    case FIT.WIDTH :
      MoveWindow( WOBJ.getHWND(), 0, cwRC.top+rbHeight, pWidth, cHeight, true ) ;
      break ;
    case FIT.HEIGHT :
      MoveWindow( WOBJ.getHWND(), cwRC.left, 0+rbHeight, cWidth, pHeight, true ) ;
      break ;
    case FIT.BOTH :
      MoveWindow( WOBJ.getHWND(), 0, 0+rbHeight, pWidth, pHeight, true ) ;
      break ;
    default : core.exception.onSwitchError() ;
    }
    return(0) ;
  }


  override LRESULT presubproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    if( msg==WM_SIZE ){
      if( tooltip !is null ){
        tooltip.reNewClientRect() ;
      }
    }
    return( this.subproc(hwnd , msg , wp , lp) ) ;
  }

}
